> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Service Accounts

> Lists service accounts in an organization.

`Unary` · [`Service Accounts`](/docs/api-reference/generated/service-account/overview)

Lists service accounts in an organization.

Use this method to:

* View all service accounts
* Audit service account usage
* Manage service account lifecycle

### Examples

* List service accounts:

  Shows all service accounts in an organization.

  ```yaml theme={null}
  pagination:
    pageSize: 20
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.ServiceAccountService/ListServiceAccounts
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.ServiceAccountService/ListServiceAccounts" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.pagination_pb2 as pagination_pb2
  import gitpod.v1.service_account_pb2 as service_account_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = service_account_pb2.ListServiceAccountsRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.service_account.list_service_accounts(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListServiceAccountsRequestSchema } from "@gitpod/sdk/gitpod/v1/service_account_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListServiceAccountsRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.serviceAccount.listServiceAccounts(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListServiceAccountsRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.ServiceAccount.ListServiceAccounts(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListServiceAccountsRequest`

| Field        | Type                                                           | Required | Description                                                         |
| ------------ | -------------------------------------------------------------- | -------- | ------------------------------------------------------------------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request)        | No       |                                                                     |
| `filter`     | [Filter](#type-gitpod-v1-list-service-accounts-request-filter) | No       | filter contains options for filtering the list of service accounts. |

## Response

`gitpod.v1.ListServiceAccountsResponse`

| Field             | Type                                                       | Required | Description |
| ----------------- | ---------------------------------------------------------- | -------- | ----------- |
| `pagination`      | [PaginationResponse](#type-gitpod-v1-pagination-response)  | No       |             |
| `serviceAccounts` | array of [ServiceAccount](#type-gitpod-v1-service-account) | No       |             |

## Related types

<a id="type-gitpod-v1-list-service-accounts-request-filter" />

<Accordion title="Filter">
  `gitpod.v1.ListServiceAccountsRequest.Filter`

  | Field               | Type            | Required | Description                                                                                                                                                                             |
  | ------------------- | --------------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `includeSuspended`  | boolean         | No       | include\_suspended includes suspended (soft-deleted) service accounts in the response. By default, suspended service accounts are excluded.                                             |
  | `serviceAccountIds` | array of string | No       | service\_account\_ids filters the response to only service accounts with the specified IDs Constraints: `repeated.items.string.uuid=true, repeated.max_items=25, repeated.min_items=0`. |
  | `search`            | string          | No       | search performs case-insensitive search across service account name, description, and ID Constraints: `string.max_len=256`.                                                             |
</Accordion>

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-service-account" />

<Accordion title="ServiceAccount">
  `gitpod.v1.ServiceAccount`

  | Field            | Type                               | Required | Description                                                                                                                                         |
  | ---------------- | ---------------------------------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `id`             | string                             | No       | Constraints: `string.uuid=true`.                                                                                                                    |
  | `organizationId` | string                             | No       | Constraints: `string.uuid=true`.                                                                                                                    |
  | `name`           | string                             | No       |                                                                                                                                                     |
  | `description`    | string                             | No       |                                                                                                                                                     |
  | `creator`        | [Subject](#type-gitpod-v1-subject) | No       |                                                                                                                                                     |
  | `createdAt`      | RFC 3339 timestamp                 | No       |                                                                                                                                                     |
  | `validUntil`     | RFC 3339 timestamp                 | No       |                                                                                                                                                     |
  | `suspended`      | boolean                            | No       | suspended indicates whether the service account has been deleted (soft-delete). Suspended service accounts cannot be used for authentication.       |
  | `systemManaged`  | boolean                            | No       | system\_managed indicates whether this is a system-managed service account. System-managed service accounts cannot be modified or deleted by users. |
</Accordion>

<a id="type-gitpod-v1-subject" />

<Accordion title="Subject">
  `gitpod.v1.Subject`

  | Field       | Type                                   | Required | Description                                                                      |
  | ----------- | -------------------------------------- | -------- | -------------------------------------------------------------------------------- |
  | `id`        | string                                 | No       | id is the UUID of the subject Constraints: `ignore=1, string.uuid=true`.         |
  | `principal` | [Principal](#enum-gitpod-v1-principal) | No       | Principal is the principal of the subject Constraints: `enum.defined_only=true`. |
</Accordion>

<a id="enum-gitpod-v1-principal" />

<Accordion title="Principal">
  | Value                       | Number | Description |
  | --------------------------- | -----: | ----------- |
  | `PRINCIPAL_UNSPECIFIED`     |      0 |             |
  | `PRINCIPAL_ACCOUNT`         |      1 |             |
  | `PRINCIPAL_USER`            |      2 |             |
  | `PRINCIPAL_RUNNER`          |      3 |             |
  | `PRINCIPAL_ENVIRONMENT`     |      4 |             |
  | `PRINCIPAL_SERVICE_ACCOUNT` |      5 |             |
  | `PRINCIPAL_RUNNER_MANAGER`  |      6 |             |
</Accordion>
